package components.Empire;

import tools.*;
import java.util.*;

/**
 * @author rholguin
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
*/

public class Empire {
	private int index;
	private int[] centerOfEmpire;
	
	private double avgSolidarity;

	private ArrayList cells;
	
	public Empire(int i) {
		cells = new ArrayList();
		
		index = i;
	}

	public void addCell(Cell cell) {
		cells.add(cell);
	}
	
	public void removeCell(Cell cell) {
		cells.remove(cell);
	}
	
	public int[] getCenterOfEmpire() {
		return centerOfEmpire = Calculations.centerOfEmpire(cells,getNumCells());
	}
	
	public double getAvgSolidarity() {
		return avgSolidarity = Calculations.avgSolidarity(cells,getNumCells());
	}
	
	public void setCellPower(int hValue) {
		if(index != 0){
			Calculations.powerLevel(cells,getNumCells(),getAvgSolidarity(),getCenterOfEmpire(),(double)hValue/100.0);
		}
		else {
			Iterator iterator = cells.iterator();
			while(iterator.hasNext()) {
				Cell c = (Cell)iterator.next();
				c.setPower(c.getSolidarity());
			}
		}
	}
	
	public ArrayList getCells() {
		return cells;
	}
	
	public int getIndex() {
		return index;
	}
	
	public int getNumCells() {
	    return cells.size();
	}
	
	public void Destroy() {
		cells = new ArrayList();
	}
}